
#include <amxmodx>
#include <amxmisc>

public plugin_init()
{
	register_plugin("Cvars Parser", "1.0", "Koka [amxmodx.ucoz.ru]")
	
	register_concmd("parse_cvars", "cmdParseCvars", -1)
}

public cmdParseCvars(id)
{
	if(id)
		return console_print(id, "* Only server console may use this command")
	
	const MAXLEN = 127
	
	new arg[16], bool:save_to_file, file_name[MAXLEN + 1], file
	read_argv(1, arg, sizeof arg -1)
	
	if(equali(arg, "save"))
	{
		save_to_file = true
		
		get_configsdir(file_name, MAXLEN)
		add(file_name, MAXLEN, "/parsed_cvars.cfg")
		
		if(!(file = fopen(file_name, "wt+")))
			return server_print("Can't open/write file '%s' =(", file_name)
	}
	
	server_print("")
	
	new i, plugin_name[MAXLEN + 1], z, y, j, pcvar_name[MAXLEN + 1], pcvar_pluginId, pcvar_point, pcvar_value[MAXLEN + 1]	
	
	for(i=0;i<get_pluginsnum();i++)
	{
		get_plugin(i, _, _, plugin_name, MAXLEN)
		
		z = 0
		y = 0
		
		for(j=0;j<get_plugins_cvarsnum();j++)
		{
			get_plugins_cvar(j, pcvar_name, MAXLEN, _, pcvar_pluginId, pcvar_point)
			
			if(i == pcvar_pluginId)
			{
				get_pcvar_string(pcvar_point, pcvar_value, MAXLEN)
				
				//       
				//     
				if(!pcvar_value[0])
					continue
				
				if(save_to_file)
				{
					if(!z++)
						fprintf(file, "// %s^n", plugin_name)
					
					fprintf(file, "%s ^"%s^"^n", pcvar_name, pcvar_value)
				}
				else
				{
					if(!z++)
						server_print("// %s", plugin_name)
					
					server_print("%s ^"%s^"", pcvar_name, pcvar_value)
				}
				
				++y
			}
		}
		
		if(y)
		{
			if(save_to_file)
				fprintf(file, "^n")
			else
				server_print("")
		}
	}
	
	if(save_to_file)
	{
		fclose(file)
		
		server_print("* Parsing content saved to '%s'^n", file_name)
	}
	else
		server_print("* If you want save this content, write 'parse_cvars save' in console^n")
	
	return 1
}

